#!/usr/bin/python2.2

import string
import gtk
import gobject
import sys
import os
sys.path.append('/usr/share/redhat-config-securitylevel')
import checklist

##
## I18N
## 
import gettext
gettext.bindtextdomain ("redhat-config-securitylevel", "/usr/share/locale")
gettext.textdomain ("redhat-config-securitylevel")
_=gettext.gettext

##
## Icon for windows
##

iconPixbuf = None      
try:
    iconPixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/redhat-config-securitylevel/pixmaps/network.png")
except:
    pass

class childWindow:
    #You must specify a runPriority for the order in which you wish your module to run
    runPriority = 50
    moduleName = _("Security Level")
    moduleClass = "reconfig"
    nameTag = _("Security Level Configuration")
    commentTag = _("Configure system security level")

    def destroy(self, args):
        gtk.mainquit()
    
    def __init__(self):
        self.doDebug = None
        self.toplevel = gtk.VBox(gtk.FALSE, 5)
        self.mainVBox = gtk.VBox(gtk.FALSE, 5)        
        self.iconBox = gtk.HBox()
        self.title = gtk.Label(_("Security Level Configuration"))
        self.title.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse ("white"))
        self.label = gtk.Label(_("Please choose the security level for the system."))
        self.label.set_line_wrap(gtk.TRUE)
        self.label.set_alignment(0.0, 0.5)
        self.securityLabel = gtk.Label(_("Security Level:"))

        self.securityOptionMenu = gtk.OptionMenu()
        self.securityMenu = gtk.Menu()
        self.highString = (_("High"))
        self.mediumString = (_("Medium"))
        self.noneString = (_("No firewall"))
        self.highItem = gtk.MenuItem(self.highString)
        self.highItem.connect("activate", self.firewall_activated)
        self.mediumItem = gtk.MenuItem(self.mediumString)
        self.mediumItem.connect("activate", self.firewall_activated)
        self.noneItem = gtk.MenuItem(self.noneString)
        self.noneItem.connect("activate", self.none_activated)
        self.securityMenu.append(self.highItem)
        self.securityMenu.append(self.mediumItem)
        self.securityMenu.append(self.noneItem)        
        self.securityOptionMenu.set_menu(self.securityMenu)
        
        self.securityBox = gtk.HBox(gtk.FALSE, 5)
        self.securityBox.pack_start(self.securityLabel, gtk.FALSE)
        self.securityBox.pack_start(self.securityOptionMenu, gtk.TRUE)
        self.defaultRadio = gtk.RadioButton(None, _("Use default firewall rules"))
        self.customRadio = gtk.RadioButton(self.defaultRadio, _("Customize"))
        self.customRadio.connect('clicked', self.enableTable)
        self.trustedLabel = gtk.Label(_("Trusted devices:"))
        self.trustedLabel.set_alignment(0.0, 0.5)
        self.trustedList = checklist.CheckList(1)
        self.trustedSW = gtk.ScrolledWindow()
        self.trustedSW.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
        self.trustedSW.set_shadow_type(gtk.SHADOW_IN)
        self.trustedSW.add(self.trustedList)        
        self.incomingLabel = gtk.Label(_("Allow incoming:"))
        self.incomingList = checklist.CheckList(1)
        self.incomingSW = gtk.ScrolledWindow()
        self.incomingSW.set_policy(gtk.POLICY_NEVER, gtk.POLICY_NEVER)
        self.incomingSW.set_shadow_type(gtk.SHADOW_IN)
        self.incomingSW.add(self.incomingList)        
        self.incomingLabel.set_alignment(0.0, 0.5)
        self.otherLabel = gtk.Label(_("Other ports: (1029:tcp)"))
        self.otherLabel.set_alignment(0.0, 0.5)
        self.otherEntry = gtk.Entry()
        self.table = gtk.Table(3, 2)
        self.table.set_row_spacings(3)
        self.table.set_col_spacings(5)
        self.table.set_sensitive(gtk.FALSE)

        #Add icon to the top frame
        p = None
        try:
            p = gtk.gdk.pixbuf_new_from_file("../pixmaps/network.png")
        except:
            try:
                p = gtk.gdk.pixbuf_new_from_file("/usr/share/redhat-config-securitylevel/pixmaps/network.png")
            except:
                pass

        if p:
            self.icon = gtk.Image()
            self.icon.set_from_pixbuf(p)

        self.devices = self.networkDevices()
        self.devices = ['eth0']
        for device in self.devices:
            self.trustedList.append_row((device, ""), gtk.FALSE)

        self.serviceList = {"DHCP":"dhcp", "SSH":"ssh", "Telnet":"telnet", "WWW (HTTP)":"http",
                     "Mail (SMTP)":"smtp", "FTP":"ftp"}
        for item in self.serviceList.keys():
            self.incomingList.append_row((item, ""), gtk.FALSE)

    def firewall_activated(self, *args):
        self.defaultRadio.set_sensitive(gtk.TRUE)
        self.customRadio.set_sensitive(gtk.TRUE)
        self.table.set_sensitive(self.customRadio.get_active())        

    def none_activated(self, *args):
        self.defaultRadio.set_sensitive(gtk.FALSE)
        self.customRadio.set_sensitive(gtk.FALSE)
        self.table.set_sensitive(gtk.FALSE)        

    def networkDevices(self):
        netdevices = []
        f = open("/proc/net/dev")
        lines = f.readlines()
        f.close()
        # skip first two lines, they are header
        lines = lines[2:]
        for line in lines:
            dev = string.strip(line[0:6])
            if dev != "lo":
                netdevices.append (dev)

        return netdevices  

    def enableTable(self, *args):
        self.table.set_sensitive(self.customRadio.get_active())

    def okClicked(self, *args):
        dlg = gtk.MessageDialog(None, 0, gtk.MESSAGE_WARNING, gtk.BUTTONS_YES_NO,
                                _("Clicking the 'Yes' button will set the security level of the "
                                "system and override any "
                                "existing firewall configuration.  Are you sure that you want "
                                "to do this?"))
        dlg.set_position(gtk.WIN_POS_CENTER)
        dlg.set_modal(gtk.TRUE)
        dlg.set_icon(iconPixbuf)
        dlg.show_all()
        result = dlg.run()

        if result == gtk.RESPONSE_YES:
            self.apply()
            self.destroy(args)
        else:
            dlg.destroy()
            return
            
    def apply(self, *args):
        path = '/usr/sbin/lokkit'
        args = ['--quiet']


        level = self.securityOptionMenu.get_children()[0].get_text()
        
        if level == self.noneString:
            args.append('--disabled')
        else:
            if level == self.highString:
                args.append('--high')
            elif level == self.mediumString:
                args.append('--medium')

        if self.customRadio.get_active():
            count = 0
            for device in self.devices:
                val = self.trustedList.get_active(count)
                if val == 1:
                    args.append('--trust=' + device)
                count = count + 1

            count = 0            
            for service in self.serviceList.keys():
                val = self.incomingList.get_active(count)
                if val == 1:
                    args.append('--port=' + self.serviceList[service] + ':tcp')
                count = count + 1

            portstring = string.strip(self.otherEntry.get_text())
            portlist = ""
            bad_token_found = 0
            bad_token = ""
            if portstring != "":
                tokens = string.split(portstring, ',')
                for token in tokens:
                    try:
                        #- if there's a colon in the token, it's valid
                        if string.index(token,':'):
                            token = string.strip(token)
                            parts = string.split(token, ':')
                            if len(parts) > 2: # more than one colon
                                bad_token_found = 1
                                bad_token = token
                            else:
                                # udp and tcp are the only valid protos
                                if parts[1] == 'tcp' or parts[1] == 'udp':
                                    args.append('--port=' + parts[0] + ":" + parts[1])
                                else: # found protocol !tcp && !udp
                                    bad_token_found = 1
                                    bad_token = token
                                    pass
                    except:
                        bad_token_found = 1
                        bad_token = token
                        pass
                    
                if bad_token_found == 1: # raise a warning
                    text = _("Invalid port given: %s.  The proper format is "
                             "'port:protocol, port:protocol'.  For example, "
                             "'1234:udp, 3456:tcp'") % (bad_token,)

                    dlg = gtk.MessageDialog(None, 0, gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, text)
                    dlg.set_modal(gtk.TRUE)
                    dlg.set_icon(iconPixbuf)
                    dlg.set_position(gtk.WIN_POS_CENTER)
                    dlg.show_all()
                    dlg.run()
                    dlg.destroy()
                    self.otherEntry.grab_focus()
                    return 0

        if self.doDebug:
            print "don't call lokkit if in debug mode"
            return 1

        lokkit = os.fork()
        if (not lokkit):
            args.insert(0, path)
            os.execv(path, args)                

        return 1

    def launch(self, doDebug = None):
        self.doDebug = doDebug

        eventBox = gtk.EventBox()
        eventBox.add(self.iconBox)
        eventBox.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse ("#cc0000"))
        self.defaultRadio.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse ("#baeeff"))
        self.customRadio.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse ("#baeeff"))
        self.table.attach(self.trustedLabel, 0, 1, 0, 1, gtk.FILL)
        self.table.attach(self.trustedSW, 1, 2, 0, 1, gtk.FILL, gtk.SHRINK)
        self.table.attach(self.incomingLabel, 0, 1, 1, 2, gtk.FILL)
        self.table.attach(self.incomingSW, 1, 2, 1, 2, gtk.FILL, gtk.SHRINK)
        self.table.attach(self.otherLabel, 0, 1, 2, 3, gtk.FILL)
        self.table.attach(self.otherEntry, 1, 2, 2, 3, gtk.FILL)
        self.mainVBox.set_border_width(10)
        self.mainVBox.set_spacing(5)

        self.iconBox.pack_start(self.icon, gtk.FALSE)
        self.iconBox.pack_start(self.title)        
        self.toplevel.pack_start(eventBox, gtk.FALSE)
        self.toplevel.pack_start(self.mainVBox, gtk.FALSE)
        self.mainVBox.pack_start(self.label, gtk.FALSE)
        self.mainVBox.pack_start(self.securityBox, gtk.FALSE)
        self.mainVBox.pack_start(gtk.HSeparator(), gtk.FALSE)
        self.mainVBox.pack_start(self.defaultRadio, gtk.FALSE)
        self.mainVBox.pack_start(self.customRadio, gtk.FALSE)
        self.mainVBox.pack_start(self.table, gtk.FALSE)

        return self.toplevel, eventBox

    def stand_alone(self):
        self.mainWindow = gtk.Window()
        self.mainWindow.set_title(_("Security Level Configuration"))
        self.mainWindow.connect("destroy", self.destroy)
        self.mainWindow.set_icon(iconPixbuf)
        self.mainWindow.set_position(gtk.WIN_POS_CENTER)
        self.mainWindow.set_border_width(10)

        bb = gtk.HButtonBox()
        bb.set_layout(gtk.BUTTONBOX_END)
        bb.set_border_width(5)
        bb.set_spacing(10)
        okButton = gtk.Button(stock='gtk-ok')
        okButton.connect("clicked", self.okClicked)
        cancelButton = gtk.Button(stock='gtk-cancel')
        cancelButton.connect("clicked", self.destroy)        
        self.table.attach(self.trustedLabel, 0, 1, 0, 1, gtk.FILL)
        self.table.attach(self.trustedSW, 1, 2, 0, 1, gtk.FILL, gtk.SHRINK)
        self.table.attach(self.incomingLabel, 0, 1, 1, 2, gtk.FILL)
        self.table.attach(self.incomingSW, 1, 2, 1, 2, gtk.EXPAND|gtk.FILL, gtk.SHRINK)
        self.table.attach(self.otherLabel, 0, 1, 2, 3, gtk.FILL)
        self.table.attach(self.otherEntry, 1, 2, 2, 3, gtk.FILL)

        bb.pack_start(cancelButton)
        bb.pack_start(okButton)

        #Packing
        self.iconBox.pack_start(self.icon, gtk.FALSE)
        self.iconBox.pack_start(self.label, gtk.FALSE)
        self.iconBox.set_spacing(5)
        self.mainWindow.add(self.toplevel)
        self.toplevel.pack_start(self.iconBox, gtk.FALSE)
        self.toplevel.pack_start(self.securityBox, gtk.FALSE)
        self.toplevel.pack_start(gtk.HSeparator(), gtk.FALSE)
        self.toplevel.pack_start(self.defaultRadio, gtk.FALSE)
        self.toplevel.pack_start(self.customRadio, gtk.FALSE)
        self.toplevel.pack_start(self.table, gtk.FALSE)
        self.toplevel.pack_start(gtk.HSeparator(), gtk.FALSE)
        self.toplevel.pack_start(bb, gtk.FALSE)

        self.mainWindow.show_all()
        gtk.mainloop()
